=== examples/natmod/heapq/Makefile ===
# Location of top-level MicroPython directory
MPY_DIR = ../../..

# Name of module (different to built-in heapq so it can coexist)
MOD = heapq_$(ARCH)

# Source files (.c or .py)
SRC = heapq.c

# Architecture to build for (x86, x64, armv7m, xtensa, xtensawin)
ARCH = x64

include $(MPY_DIR)/py/dynruntime.mk
