=== debian/changelog ===
micropython (1.24.0+ds-1) unstable; urgency=medium

  * New upstream release
    * Fix FTBFS with MbedTLS 3.6 (Closes: #1075865)
    * Fix CVE-2024-8946 CVE-2024-8947 CVE-2024-8948 (Closes: #1082511)
  * Bump Standards-Version to 4.7.0

 -- Yangfl <mmyangfl@gmail.com>  Sun, 27 Oct 2024 10:51:24 +0800
