=== debian/control ===
Source: micropython
Maintainer: Yangfl <mmyangfl@gmail.com>
Section: python
Priority: optional
Build-Depends:
 debhelper-compat (= 13),
 python3,
Build-Depends-Arch:
 pkg-config,
 libffi-dev,
 libmbedtls-dev,
 default-jdk-headless,
Build-Depends-Indep:
 python3-sphinx,
 python3-sphinxcontrib.jquery,
 python3-doc,
Rules-Requires-Root: no
Standards-Version: 4.7.0
Homepage: https://micropython.org/
Vcs-Browser: https://salsa.debian.org/yangfl-guest/micropython
Vcs-Git: https://salsa.debian.org/yangfl-guest/micropython.git

Package: micropython
Architecture: any
Depends:
 ${misc:Depends},
 ${shlibs:Depends},
Suggests:
 default-jre-headless,
Description: Unix/Linux port of MicroPython for board-independent use on the host
 The Unix port of MicroPython allows testing of programs intended for
 microcontrollers on the local Debian host machine (except for hardware-specific
 parts). It can also be used as another, tiny but mostly compatible, Python 3
 runtime for small scripts (but it comes with FFI and JNI support). This port
 uses optimised assembly code on ARM/Thumb, MIPS, i386 and amd64, and
 setjmp/longjmp-based fallback code on all other architectures.

Package: micropython-doc
Architecture: all
Depends:
 ${misc:Depends},
 ${sphinxdoc:Depends},
Built-Using:
 ${sphinxdoc:Built-Using},
Suggests:
 python3-doc,
Section: doc
Multi-Arch: foreign
Description: Documentation and examples for MicroPython - HTML format
 The Unix port of MicroPython allows testing of programs intended for
 microcontrollers on the local Debian host machine (except for hardware-specific
 parts). It can also be used as another, tiny but mostly compatible, Python 3
 runtime for small scripts (but it comes with FFI and JNI support). This port
 uses optimised assembly code on ARM/Thumb, MIPS, i386 and amd64, and
 setjmp/longjmp-based fallback code on all other architectures.
 .
 This contains the documentation in HTML format.
